fi
if test -f "$4"; then
rm -f -- "$4" &&
- rmdir -p "$(expr "$4" : '\(.*\)/')" 2>/dev/null
+ rmdir -p "$(expr "z$4" : 'z\(.*\)/')" 2>/dev/null || :
fi &&
exec git-update-index --remove -- "$4"
;;
# Modified in both, but differently.
#
"$1$2$3" | ".$2$3")
+
+ case ",$6,$7," in
+ *,120000,*)
+ echo "ERROR: $4: Not merging symbolic link changes."
+ exit 1
+ ;;
+ esac
+
src2=`git-unpack-file $3`
case "$1" in
'')
expr "$sz0" \< "$sz1" \* 2 >/dev/null || : >$orig
;;
*)
- echo "Auto-merging $4."
+ echo "Auto-merging $4"
orig=`git-unpack-file $1`
;;
esac
- # We reset the index to the first branch, making
- # git-diff-file useful
- git-update-index --add --cacheinfo "$6" "$2" "$4"
- git-checkout-index -u -f -- "$4" &&
- merge "$4" "$orig" "$src2"
+ # Be careful for funny filename such as "-L" in "$4", which
+ # would confuse "merge" greatly.
+ src1=`git-unpack-file $2`
+ merge "$src1" "$orig" "$src2"
ret=$?
- rm -f -- "$orig" "$src2"
+
+ # Create the working tree file, using "our tree" version from the
+ # index, and then store the result of the merge.
+ git-checkout-index -f --stage=2 -- "$4" && cat "$src1" >"$4"
+ rm -f -- "$orig" "$src1" "$src2"
if [ "$6" != "$7" ]; then
echo "ERROR: Permissions conflict: $5->$6,$7."
fi
if [ $ret -ne 0 ]; then
- echo "ERROR: Merge conflict in $4."
+ echo "ERROR: Merge conflict in $4"
exit 1
fi
exec git-update-index -- "$4"